#ifndef IMAGESSET_H
#define IMAGESSET_H

namespace Basics3D
{
	template<class Image>
  class T_ImagesSet
	{
private:
		std::vector<Image *> m_img;

	public:
		T_ImagesSet(char *in_argv[],
			         int in_N)
		{
		  for (int i = 0; i < in_N; i++)
			{
			  AImage *_tmp = ::AImageLoad(0, true, in_argv[i + 3], indicator);
				Image *tmp = dynamic_cast<Image *>(_tmp);

				if (tmp == 0)
				{
					std::cout << "Image " << i << " wasn't loaded";
					delete _tmp;
				}
				else
				{
					m_img.push_back(tmp);
				}
			}
		}
	
		/////////////////////////////////////////////////////////////////////////////////////
		Image *operator[](int i) const
		{
		  return m_img[i];
		}

		/////////////////////////////////////////////////////////////////////////////////////
		int Size() const
		{
		  return m_img.size();
		}

		/////////////////////////////////////////////////////////////////////////////////////
		~T_ImagesSet()
		{
		  for (int i = 0; i < Size(); i++)
			{
			  delete m_img[i];
			}
		}
	};
}

#endif // IMAGESSET_H
