#ifndef _TRIRESULT_H
#define _TRIRESULT_H
/////////////////////////////////////////
#include "sfm_mesh_triangle.h"
#include "num_linalg.h"
//#include "YMatrix.h"

//using namespace F3D;

/////////////////////////////////////////
	/**
	 * 
	 *   ...
	 * 
	 */
	class TriResult
	{
		typedef boost::numeric::ublas::matrix<double> Matrix;
		int F;								// :   | -->1..P
		int P;								// :                      V 1..F
		int nTri,nCorn;
		Matrix uv;
		Matrix tri;
		struct triangulateio in, mid, out, vorout;

	private:
		void report(struct triangulateio *io);
		void ExeTri();

	public:
		void RunTri(Matrix& W);
		void Build_texture(const Matrix& W,int numpic, Matrix& W_tex);	 //    
		void BuildVRML(const char *fname, const Matrix& X, const Matrix& R, const Matrix& t,
			const char *texfile, const Matrix& W_tex,const Matrix& g);
	};

/////////////////////////////////////////
#endif //_TRIRESULT_H
