
#ifndef IMAGE_CONTAINER_H
#define IMAGE_CONTAINER_H

//system includings
#include <vector>
#include <math.h>

template <typename ImgType>
class ImageContainer
{
private:
	std::vector<ImgType> m_images;

public:
	int Add(ImgType img)
	{
	  m_images.push_back(img);
		return (m_images.size() - 1);
	}

	//---------------------------------------------------------------------------
	void Delete(int i)
	{
	  delete(m_images[i]);
		m_images.erase(m_images.begin() + i);
	}

	//---------------------------------------------------------------------------
	const ImgType *operator[](int i) const
	{
	  return &(m_images[i]);
	}

	//---------------------------------------------------------------------------
	int size() const
	{
		return m_images.size();
	}
	/*~ImageContainer()
	{
		int n = m_images.size();
		for (int i = 0; i < n; i++)
		{
			delete(m_images[i]);
		}
	}*/
};

#endif //IMAGE_CONTAINER_H