#include <iostream>
#include "alexandresku.h"
#include "tests.h"

int Tests::test_alexandresku(int argc,char* argv[])
{
	unsigned n;
	n=Vtl::Alg::Factorial<0>::value;
	std::cout << "Vtl::Alg::Factorial<0>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<1>::value;
	std::cout << "Vtl::Alg::Factorial<1>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<2>::value;
	std::cout << "Vtl::Alg::Factorial<2>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<3>::value;
	std::cout << "Vtl::Alg::Factorial<3>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<4>::value;
	std::cout << "Vtl::Alg::Factorial<4>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<5>::value;
	std::cout << "Vtl::Alg::Factorial<5>::value="<< n << std::endl;
	n=Vtl::Alg::Factorial<6>::value;
	std::cout << "Vtl::Alg::Factorial<6>::value="<< n << std::endl;

	n=Vtl::Alg::isOdd<0>::value;
	std::cout << "0"<< " :  isOdd=" << n << std::endl;
	n=Vtl::Alg::isOdd<1>::value;
	std::cout << "1"<< " :  isOdd=" << n << std::endl;
	n=Vtl::Alg::isOdd<2>::value;
	std::cout << "2"<< " :  isOdd=" << n << std::endl;
	n=Vtl::Alg::isOdd<3>::value;
	std::cout << "3"<< " :  isOdd=" << n << std::endl;
	n=Vtl::Alg::isOdd<4>::value;
	std::cout << "4"<< " :  isOdd=" << n << std::endl;
	n=Vtl::Alg::isOdd<5>::value;
	std::cout << "5"<< " :  isOdd=" << n << std::endl;

	unsigned x=2;
	unsigned r;
	r=Vtl::Alg::x_to_N<0>::value(x);
	std::cout << "x="<< x <<",  n="<< 0 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<1>::value(x);
//	r=Vtl::Alg::n_pow(x,Vtl::Types::Int2Type<1>());
	std::cout << "x="<< x <<",  n="<< 1 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<2>::value(x);
//	r=Vtl::Alg::n_pow(x,Vtl::Types::Int2Type<2>());
	std::cout << "x="<< x <<",  n="<< 2 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<3>::value(x);
//	r=Vtl::Alg::n_pow(x,Vtl::Types::Int2Type<3>());
	std::cout << "x="<< x <<",  n="<< 3 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<4>::value(x);
//	r=Vtl::Alg::n_pow(x,Vtl::Types::Int2Type<4>());
	std::cout << "x="<< x <<",  n="<< 4 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<5>::value(x);
	std::cout << "x="<< x <<",  n="<< 5 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<6>::value(x);
	std::cout << "x="<< x <<",  n="<< 6 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<7>::value(x);
	std::cout << "x="<< x <<",  n="<< 7 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<8>::value(x);
	std::cout << "x="<< x <<",  n="<< 8 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<9>::value(x);
	std::cout << "x="<< x <<",  n="<< 9 << "  x^n="<< r << std::endl;
	r=Vtl::Alg::x_to_N<10>::value(x);
	std::cout << "x="<< x <<",  n="<< 10 << "  x^n="<< r << std::endl;

	float f;
	f=Vtl::Alg::dsin<0>(float(M_PI/6));
	std::cout << "dsin<0>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<1>(float(M_PI/6));
	std::cout << "dsin<1>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<2>(float(M_PI/6));
	std::cout << "dsin<2>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<3>(float(M_PI/6));
	std::cout << "dsin<3>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<4>(float(M_PI/6));
	std::cout << "dsin<4>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<5>(float(M_PI/6));
	std::cout << "dsin<5>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<6>(float(M_PI/6));
	std::cout << "dsin<6>(30 deg)="<< f << std::endl;
	f=Vtl::Alg::dsin<7>(float(M_PI/6));
	std::cout << "dsin<7>(30 deg)="<< f << std::endl;



	return 0;
}
