#ifndef ABS_DIFFERENCE_H
#define ABS_DIFFERENCE_H

// library includings
#include "aimage.h"
#include "imalg_resampling.h"
#include "imalg_tools.h"
#include "consolap.h"

namespace Basics3D
{
	class C_AbsDifference
	{
	private:
		const AImageMem8* m_im1;
		const AImageMem8* m_im2;
		AImageMem8* m_dif;

	public:
		C_AbsDifference(const AImageMem8* in_im1,
										const AImageMem8* in_im2);

		void Apply();

		void Save(const char *in_filename);

		//~C_AbsDifference();
	};
}
#endif // ABS_DIFFERENCE_H
