/*! \page plf_background   
 *	@htmlinclude plf_buffer.htm 
 */
/*! \page plf_readme ReadMe
 *  @verbinclude ReadMe.txt
 */
/*! \page plf_shared_info     
 *  @verbinclude Shared-info.txt
 */
/*! \page plf_some_tests  
 *	
 *	
 *  Some graph diagramm:
 * \dot
 *  digraph example {
 *    node [shape=record, fontname=Helvetica, fontsize=12];
 *    a [ label="Src" ];
 *    h [ label="Conv-H" URL="\ref Vtl::Plf::ConvolveHorz" ];
 *    b [ label="Conv-H deriv" ];
 *    c [ label="Conv-V deriv" ];
 *    d [ label="Conv-V" ];
 *    e [ label="Sqrt(I1^2+I2^2)" ];
 *    f [ label="Gamma Correction" ];
 *    g [ label="Dest" ];
 *    a -> b [ arrowhead="open", style="solid" ];
 *    a -> h [ arrowhead="open", style="solid" ];
 *    h -> c [ arrowhead="open", style="dashed" ];
 *    b -> d [ arrowhead="open", style="solid" ];
 *    c -> e [ arrowhead="open", style="dashed" ];
 *    d -> e ;
 *    e -> f [ arrowhead="open", style="dashed" ];
 *    f -> g [ arrowhead="open", style="dashed" ];
 * }
 * \enddot
 *	
 *	
 */
/*! \mainpage  
 *
 * \section intro_sec  
 *
 *  :
 * -#        \ref AbstractImage
 *    -  
 *    -    
 *    -   
 *    -  : pgm, ppm,tiff, bmp, oz, iff (     float)
 *    - ,          
 *    -      Windows 
 * -#      \ref PipeLineFiltersDoxGroup
 * -#    \ref GeneralGroup,     
 *    -   
 *    -  INI  XML ,
 *    -    
 *    -    
 *    -  
 * -#   \ref NumericalMethodsDoxGroup ,  
 *    -  ( nmQUANC8 )
 *    -   (nmSPLINE nmSPLINE_FREE nmSEVAL)
 *    -     (nmZEROIN)
 *    -      (nmFMIN)
 *    -   (nmSVD)
 *    -   (nmVTRAN)
 *    -       (nmTStudentPerc****)
 *    -    (nmGAMMLN)
 *    -   (nmPoly)
 *
 *
 * \section intro_sec1     (Background)
 *  @li @ref plf_readme 
 *  @li @ref plf_shared_info
 *  @li @ref dox_gen_worh_with_image
 *  @li @ref dox_gen_c_sharp_pix_access
 *  @li @ref dox_gen_file_mapping_to_mem
 *  @li @ref plf_background 
 *
 */