#ifndef _IFLOAT_H
#define _IFLOAT_H
#include "yfile.h"

typedef float FloatWord;
namespace IFF
{

//class FloatImageFileRead
class FloatImageFile
//: public YFileRead
: protected YFile
{
public:
#pragma pack(push,1)
	struct Header
	{
		Byte id[16];//"FloatImageFile"
		uint32_t hdrsize;//sizeof(FloatImageFileRead::Header)
		uint32_t width;
		uint32_t height;
		uint32_t reserved[12];
	};
#pragma pack(pop)
private:
	Header head;
public:
//	 
	void writeHeader();
	void readHeader();
public:
//	/ 
	FloatImageFile();
	virtual ~FloatImageFile();
	void open(const char * szFileName,OpenMode access,
				int  Width=0,int  Heigth=0);
	void close();
	//--------------------------------------------------
	void read(int x,int y,FloatWord *line,int len);
	void write(int x,int y,const FloatWord *line,int len);
	//------------------------------------------------
	int Width()  const { return head.width; }
	int Height() const { return head.height; }
};
} //namespace IFF
#endif//_IFLOAT_H
